info_magnolia_ui_vaadin_extension_ResurfacedWindow = function() {
    const dialog = document.querySelector('.v-window.dialog');
    const dialogContents = document.querySelector('.v-window.dialog .v-window-contents');
    const tabHeightPx = dialogContents.querySelector('.v-tabsheet-tabcontainer').clientHeight;
    const dialogFooterHeaderHeightPx = document.querySelector('.dialog .actions').clientHeight;
    const dialogMarginPx = 30;
    // dialog's margins, tab, footer and header must be removed from the available height
    const offsetHeight = (dialogMarginPx * 2) + (dialogFooterHeaderHeightPx * 2) + tabHeightPx;

    this.onStateChange = function() {
        if (dialog && dialog.classList.contains('light')) {
            const curtain = dialog.parentNode.querySelector('.v-window-modalitycurtain');
            if (curtain) {
                curtain.classList.add("light");
            }
        }
    }

    this.addResizeListener(dialogContents, function () {
        const tabPanel = dialogContents.querySelector('div[role="tabpanel"]');
        if (tabPanel && tabPanel.scrollHeight + offsetHeight > window.innerHeight) {
            tabPanel.style.maxHeight = window.innerHeight - offsetHeight + 'px';
            tabPanel.style.overflow = 'auto';
        }
    });
}